libstdc++: std::unique_ptr< _Tp, _Dp > Class Template Reference

libstdc++

std::unique_ptr< _Tp, _Dp > Class Template Reference
Utilities » Memory » Pointer Abstractions

`#include <memory>`

## Public Types
using | deleter_type
using | element_type
using | pointer

## Public Member Functions
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>
constexpr | unique_ptr () noexcept
template<typename _Up, typename = _Require<is_convertible<_Up*, pointer>, is_same<_Dp, default_delete<_Tp>>>>
| unique_ptr (auto_ptr< _Up > &&__u) noexcept
| unique_ptr (const unique_ptr &)=delete
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>
constexpr | unique_ptr (nullptr_t) noexcept
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>
constexpr | unique_ptr (pointer __p) noexcept
template<typename _Del = deleter_type, typename = _Require<is_move_constructible<_Del>>>
constexpr | unique_ptr (pointer __p, __enable_if_t<!is_lvalue_reference< _Del >::value, _Del && > __d) noexcept
template<typename _Del = deleter_type, typename = _Require<is_copy_constructible<_Del>>>
constexpr | unique_ptr (pointer __p, const deleter_type &__d) noexcept
template<typename _Del = deleter_type, typename _DelUnref = typename remove_reference<_Del>::type>
constexpr | unique_ptr (pointer, __enable_if_t< is_lvalue_reference< _Del >::value, _DelUnref && >)=delete
| unique_ptr (unique_ptr &&)=default
template<typename _Up, typename _Ep, typename = _Require< __safe_conversion_up<_Up, _Ep>, __conditional_t<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>>>
constexpr | unique_ptr (unique_ptr< _Up, _Ep > &&__u) noexcept
constexpr | ~unique_ptr () noexcept
constexpr pointer | get () const noexcept
constexpr const deleter_type & | get_deleter () const noexcept
constexpr deleter_type & | get_deleter () noexcept
constexpr | operator bool () const noexcept
constexpr add_lvalue_reference< element_type >::type | operator* () const noexcept(noexcept(*std::declval< pointer >()))
constexpr pointer | operator-> () const noexcept
unique_ptr & | operator= (const unique_ptr &)=delete
constexpr unique_ptr & | operator= (nullptr_t) noexcept
unique_ptr & | operator= (unique_ptr &&)=default
template<typename _Up, typename _Ep>
constexpr enable_if< __and_< __safe_conversion_up< _Up, _Ep >, is_assignable< deleter_type &, _Ep && > >::value, unique_ptr & >::type | operator= (unique_ptr< _Up, _Ep > &&__u) noexcept
constexpr pointer | release () noexcept
constexpr void | reset (pointer __p=pointer()) noexcept
constexpr void | swap (unique_ptr &__u) noexcept

## Friends
template<typename, typename, typename...>
class | inout_ptr_t
template<typename, typename, typename...>
class | out_ptr_t

## Related Symbols
(Note that these are not member symbols.)
template<typename _CharT, typename _Traits, typename _Tp, typename _Dp>
basic_ostream< _CharT, _Traits > & | operator<< (basic_ostream< _CharT, _Traits > &__os, const unique_ptr< _Tp, _Dp > &__p)
template<typename _Tp, typename _Dp>
constexpr enable_if< __is_swappable< _Dp >::value >::type | swap (unique_ptr< _Tp, _Dp > &__x, unique_ptr< _Tp, _Dp > &__y) noexcept

## Detailed Description

template<typename _Tp, typename _Dp = default_delete<_Tp>>
class std::unique_ptr< _Tp, _Dp >

A move-only smart pointer that manages unique ownership of a resource.

Since
  C++11

Definition at line 270 of file unique_ptr.h.

## Member Typedef Documentation

## ◆ deleter_type

template<typename _Tp, typename _Dp = default_delete<_Tp>>

using std::unique_ptr< _Tp, _Dp >::deleter_type

Definition at line 281 of file unique_ptr.h.

## ◆ element_type

template<typename _Tp, typename _Dp = default_delete<_Tp>>

using std::unique_ptr< _Tp, _Dp >::element_type

Definition at line 280 of file unique_ptr.h.

## ◆ pointer

template<typename _Tp, typename _Dp = default_delete<_Tp>>

using std::unique_ptr< _Tp, _Dp >::pointer

Definition at line 279 of file unique_ptr.h.

## Constructor & Destructor Documentation

## ◆ unique_ptr() [1/8]

template<typename _Tp, typename _Dp = default_delete<_Tp>>
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>

std::unique_ptr< _Tp, _Dp >::unique_ptr | ( |  | ) |
| inlineconstexprnoexcept

Default constructor, creates a unique_ptr that owns nothing.

Definition at line 297 of file unique_ptr.h.

## ◆ unique_ptr() [2/8]

template<typename _Tp, typename _Dp = default_delete<_Tp>>
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>

std::unique_ptr< _Tp, _Dp >::unique_ptr | ( | pointer | __p | ) |
| inlineexplicitconstexprnoexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an object of `element_type`

The deleter will be value-initialized.

Definition at line 310 of file unique_ptr.h.

## ◆ unique_ptr() [3/8]

template<typename _Tp, typename _Dp = default_delete<_Tp>>
template<typename _Del = deleter_type, typename = _Require<is_copy_constructible<_Del>>>

std::unique_ptr< _Tp, _Dp >::unique_ptr | ( | pointer | __p,
|  | const deleter_type & | __d )
| inlineconstexprnoexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an object of `element_type`
  __d | A reference to a deleter.

The deleter will be initialized with `__d`

Definition at line 324 of file unique_ptr.h.

## ◆ unique_ptr() [4/8]

template<typename _Tp, typename _Dp = default_delete<_Tp>>
template<typename _Del = deleter_type, typename = _Require<is_move_constructible<_Del>>>

std::unique_ptr< _Tp, _Dp >::unique_ptr | ( | pointer | __p,
|  | __enable_if_t<!is_lvalue_reference< _Del >::value, _Del && > | __d )
| inlineconstexprnoexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an object of `element_type`
  __d | An rvalue reference to a (non-reference) deleter.

The deleter will be initialized with `std::move(__d)`

Definition at line 337 of file unique_ptr.h.

## ◆ unique_ptr() [5/8]

template<typename _Tp, typename _Dp = default_delete<_Tp>>
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>

std::unique_ptr< _Tp, _Dp >::unique_ptr | ( | nullptr_t |  | ) |
| inlineconstexprnoexcept

Creates a unique_ptr that owns nothing.

Definition at line 352 of file unique_ptr.h.

## ◆ unique_ptr() [6/8]

template<typename _Tp, typename _Dp = default_delete<_Tp>>

std::unique_ptr< _Tp, _Dp >::unique_ptr | ( | unique_ptr< _Tp, _Dp > && |  | ) |
| default

Move constructor.

## ◆ unique_ptr() [7/8]

template<typename _Tp, typename _Dp = default_delete<_Tp>>
template<typename _Up, typename _Ep, typename = _Require< __safe_conversion_up<_Up, _Ep>, __conditional_t<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>>>

std::unique_ptr< _Tp, _Dp >::unique_ptr | ( | unique_ptr< _Up, _Ep > && | __u | ) |
| inlineconstexprnoexcept

Converting constructor from another type.

Requires that the pointer owned by `__u` is convertible to the type of pointer owned by this object, `__u` does not own an array, and `__u` has a compatible deleter type.

Definition at line 373 of file unique_ptr.h.

## ◆ unique_ptr() [8/8]

template<typename _Tp, typename _Dp>
template<typename _Up, typename>

std::unique_ptr< _Tp, _Dp >::unique_ptr | ( | auto_ptr< _Up > && | __u | ) |
| inlinenoexcept

Converting constructor from `auto_ptr`.

Definition at line 334 of file auto_ptr.h.

## ◆ ~unique_ptr()

template<typename _Tp, typename _Dp = default_delete<_Tp>>

std::unique_ptr< _Tp, _Dp >::~unique_ptr | ( |  | ) |
| inlineconstexprnoexcept

Destructor, invokes the deleter if the stored pointer is not null.

Definition at line 392 of file unique_ptr.h.

## Member Function Documentation

## ◆ get()

template<typename _Tp, typename _Dp = default_delete<_Tp>>

pointer std::unique_ptr< _Tp, _Dp >::get | ( |  | ) | const
| inlineconstexprnoexcept

Return the stored pointer.

Definition at line 471 of file unique_ptr.h.

Referenced by std::unique_ptr< _State >::operator bool(), std::unique_ptr< _State >::operator*(), std::unique_ptr< _State >::operator->(), std::operator<(), std::operator<(), std::operator<(), std::unique_ptr< _State >::operator<<(), std::operator==(), std::operator>(), and std::operator>().

## ◆ get_deleter() [1/2]

template<typename _Tp, typename _Dp = default_delete<_Tp>>

const deleter_type & std::unique_ptr< _Tp, _Dp >::get_deleter | ( |  | ) | const
| inlineconstexprnoexcept

Return a reference to the stored deleter.

Definition at line 483 of file unique_ptr.h.

## ◆ get_deleter() [2/2]

template<typename _Tp, typename _Dp = default_delete<_Tp>>

deleter_type & std::unique_ptr< _Tp, _Dp >::get_deleter | ( |  | ) |
| inlineconstexprnoexcept

Return a reference to the stored deleter.

Definition at line 477 of file unique_ptr.h.

Referenced by std::unique_ptr< _State >::~unique_ptr(), and std::unique_ptr< _State >::operator=().

## ◆ operator bool()

template<typename _Tp, typename _Dp = default_delete<_Tp>>

std::unique_ptr< _Tp, _Dp >::operator bool | ( |  | ) | const
| inlineexplicitconstexprnoexcept

Return `true` if the stored pointer is not null.

Definition at line 488 of file unique_ptr.h.

## ◆ operator*()

template<typename _Tp, typename _Dp = default_delete<_Tp>>

add_lvalue_reference< element_type >::type std::unique_ptr< _Tp, _Dp >::operator* | ( |  | ) | const
| inlineconstexprnoexcept

Dereference the stored pointer.

Definition at line 445 of file unique_ptr.h.

## ◆ operator->()

template<typename _Tp, typename _Dp = default_delete<_Tp>>

pointer std::unique_ptr< _Tp, _Dp >::operator-> | ( |  | ) | const
| inlineconstexprnoexcept

Return the stored pointer.

Definition at line 462 of file unique_ptr.h.

## ◆ operator=() [1/3]

template<typename _Tp, typename _Dp = default_delete<_Tp>>

unique_ptr & std::unique_ptr< _Tp, _Dp >::operator= | ( | nullptr_t |  | ) |
| inlineconstexprnoexcept

Reset the unique_ptr to empty, invoking the deleter if necessary.

Definition at line 434 of file unique_ptr.h.

## ◆ operator=() [2/3]

template<typename _Tp, typename _Dp = default_delete<_Tp>>

unique_ptr & std::unique_ptr< _Tp, _Dp >::operator= | ( | unique_ptr< _Tp, _Dp > && |  | ) |
| default

Move assignment operator.

Invokes the deleter if this object owns a pointer.

## ◆ operator=() [3/3]

template<typename _Tp, typename _Dp = default_delete<_Tp>>
template<typename _Up, typename _Ep>

enable_if< __and_< __safe_conversion_up< _Up, _Ep >, is_assignable< deleter_type &, _Ep && > >::value, unique_ptr & >::type std::unique_ptr< _Tp, _Dp >::operator= | ( | unique_ptr< _Up, _Ep > && | __u | ) |
| inlineconstexprnoexcept

Assignment from another type.

Parameters

  __u | The object to transfer ownership from, which owns a convertible pointer to a non-array object.

Invokes the deleter if this object owns a pointer.

Definition at line 424 of file unique_ptr.h.

## ◆ release()

template<typename _Tp, typename _Dp = default_delete<_Tp>>

pointer std::unique_ptr< _Tp, _Dp >::release | ( |  | ) |
| inlineconstexprnoexcept

Release ownership of any stored pointer.

Definition at line 496 of file unique_ptr.h.

## ◆ reset()

template<typename _Tp, typename _Dp = default_delete<_Tp>>

void std::unique_ptr< _Tp, _Dp >::reset | ( | pointer | __p = pointer() | ) |
| inlineconstexprnoexcept

Replace the stored pointer.

Parameters

  __p | The new pointer to store.

The deleter will be invoked if a pointer is already owned.

Definition at line 507 of file unique_ptr.h.

Referenced by std::unique_ptr< _State >::operator=(), and std::unique_ptr< _State >::operator=().

## ◆ swap()

template<typename _Tp, typename _Dp = default_delete<_Tp>>

void std::unique_ptr< _Tp, _Dp >::swap | ( | unique_ptr< _Tp, _Dp > & | __u | ) |
| inlineconstexprnoexcept

Exchange the pointer and deleter with another object.

Definition at line 517 of file unique_ptr.h.

## Friends And Related Symbol Documentation

## ◆ inout_ptr_t

template<typename _Tp, typename _Dp = default_delete<_Tp>>
template<typename, typename, typename...>

friend class inout_ptr_t
| friend

Definition at line 532 of file unique_ptr.h.

## ◆ out_ptr_t

template<typename _Tp, typename _Dp = default_delete<_Tp>>
template<typename, typename, typename...>

friend class out_ptr_t
| friend

Definition at line 530 of file unique_ptr.h.

The documentation for this class was generated from the following files:

- unique_ptr.h
- auto_ptr.h